/* $Id: Calculation.java,v 1.2 2006/05/30 21:18:17 gsson Exp $ */

/*
 * Copyright (c) 2006 Henrik Gustafsson <henrik.gustafsson@fnord.se>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

package se.fnord.ecalc;

import java.util.Properties;

public class Calculation {
	private final String expression;

	private final String result;

	private static final String format = "<p vspace='true'>EXPRESSION</p>"
			+ "<li vspace='false' style='text' value='&gt;' bindent='0' indent='50'><b>RESULT</b></li>";

	public Calculation(String expression, String result) {
		this.expression = expression;
		this.result = result;

	}

	public String getExpression() {
		return this.expression;
	}

	public String getResult() {
		return this.result;
	}

	public String getFormatted(Properties messages) {

		String r = result;
		if (r.startsWith("%")) {
			r = messages.getProperty(r.substring(1), r);
		}
		
		r.replaceAll("&", "&amp;").replaceAll("<", "&lt;").replaceAll(">",
				"&gt;");
		expression.replaceAll("&", "&amp;").replaceAll("<", "&lt;").replaceAll(
				">", "&gt;");

		return format.replaceAll("EXPRESSION", expression).replaceAll("RESULT", r);
		
	}
}
