/* $Id: Hypotenuse.java,v 1.6 2006/05/30 19:20:48 gsson Exp $ */

/*
 * Copyright (c) 2006 Henrik Gustafsson <henrik.gustafsson@fnord.se>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

package se.fnord.ecalc.parser.functions;

import se.fnord.ecalc.parser.ExpressionException;
import se.fnord.ecalc.parser.ExpressionParserContext;
import se.fnord.ecalc.parser.IFunction;
import se.fnord.ecalc.parser.IValue;
import se.fnord.ecalc.parser.Literal;

public class Hypotenuse implements IFunction {

	public IValue execute(IValue[] params, ExpressionParserContext context) throws ExpressionException {
		if (params == null || params.length != 2)
			throw new ExpressionException("%se.fnord.ecalc.exceptions.expressionexception.arity");
		
		double x = params[0].toDouble();
		double y = params[1].toDouble();
		return new Literal(Math.sqrt( x*x+y*y )); 
	}

}
